/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.Logger
 *  fire.log.YYLogger
 *  fire.log.beans.ItemBaseBean
 *  fire.log.beans.RegBean
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.PropRole
 *  fire.pb.fushi.PAddFuShi
 *  fire.pb.game.Sregreward
 *  fire.pb.item.Pack
 *  fire.pb.talk.MessageMgr
 *  fire.pb.util.MessageUtil
 *  fire.pb.util.singlefactory.SingleContainer
 *  mkdb.Procedure
 *  xbean.RegDay
 *  xbean.RegMonth
 *  xbean.RegRec
 */
package fire.pb.activity.reg;

import fire.log.Logger;
import fire.log.YYLogger;
import fire.log.beans.ItemBaseBean;
import fire.log.beans.RegBean;
import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.PropRole;
import fire.pb.activity.reg.PQueryRegRec;
import fire.pb.activity.reg.RegAssistant;
import fire.pb.activity.reg.RoleProcedure;
import fire.pb.fushi.PAddFuShi;
import fire.pb.game.Sregreward;
import fire.pb.item.Pack;
import fire.pb.talk.MessageMgr;
import fire.pb.util.MessageUtil;
import fire.pb.util.singlefactory.SingleContainer;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Map;
import mkdb.Procedure;
import xbean.RegDay;
import xbean.RegMonth;
import xbean.RegRec;

public class PRegReward
extends RoleProcedure {
    private RegAssistant regAssistant;
    private static Logger logger = Logger.getLogger((String)"AWARD");

    public PRegReward(long roleId, RegAssistant assistant) {
        super(roleId);
        this.regAssistant = assistant;
    }

    public PRegReward(long roleId) {
        this(roleId, (RegAssistant)SingleContainer.getInstance(RegAssistant.class));
    }

    protected boolean process() throws Exception {
        Calendar calen = Calendar.getInstance();
        int monthOfYear = this.regAssistant.getMonthOfYear(calen);
        int dayOfMonth = this.regAssistant.getDayOfMonth(calen);
        if (this.roleId < 0L) {
            logger.error((Object)("PRegReward error:roleid:" + this.roleId));
            return false;
        }
        RegRec regRec = this.regAssistant.getRecord(this.roleId);
        Pack itemBag = new Pack(this.roleId, false);
        PropRole propRole = new PropRole(this.roleId, true);
        int vipLv = this.regAssistant.getVipLv(this.roleId);
        if (!regRec.getMonthmap().containsKey(monthOfYear)) {
            logger.error((Object)("PRegReward error:没有该月的记录  roleid:" + this.roleId + " month:" + monthOfYear));
            return false;
        }
        Map dayMap = ((RegMonth)regRec.getMonthmap().get(monthOfYear)).getDaymap();
        if (!dayMap.containsKey(dayOfMonth)) {
            logger.error((Object)("PRegReward error:没有该日的记录  roleid:" + this.roleId + " day:" + dayOfMonth));
            return false;
        }
        int regTimesOfMonth = this.regAssistant.getRegTimesOfMonth(dayMap);
        if (((RegDay)dayMap.get(dayOfMonth)).getRewardflag() > 0) {
            logger.error((Object)("PRegReward error:今天已经领取过奖励  roleid:" + this.roleId + " day:" + dayOfMonth));
            return false;
        }
        int rewardIdx = this.getRewardIdx(dayMap, monthOfYear);
        if (rewardIdx < 1) {
            logger.error((Object)("PRegReward error:奖励id错误  roleid:" + this.roleId + " rewardId:" + rewardIdx));
            return false;
        }
        Sregreward sRegRewardConf = (Sregreward)this.configManager.getConfigById(Sregreward.class, rewardIdx);
        if (sRegRewardConf == null) {
            logger.error((Object)("PRegReward error:奖励未配置  roleid:" + this.roleId + " rewardId:" + rewardIdx));
            return false;
        }
        int vipRatio = this.vipRatio(sRegRewardConf, vipLv);
        ((RegDay)dayMap.get(dayOfMonth)).setRewardflag(1);
        regRec.setLastregtime(calen.getTimeInMillis());
        logger.info((Object)("PRegReward 签到奖励成功领取  roleid:" + this.roleId + " day:" + dayOfMonth + " rewardId:" + rewardIdx));
        return this.sendReward(propRole.getUserid(), sRegRewardConf, itemBag, vipRatio, regTimesOfMonth);
    }

    private int getRewardIdx(Map<Integer, RegDay> dayMap, int month) {
        int allRegTimesOfMonth = this.regAssistant.getRegTimesOfMonth(dayMap);
        if (allRegTimesOfMonth == 0) {
            return 0;
        }
        return allRegTimesOfMonth + month * 100;
    }

    protected boolean sendReward(int userId, Sregreward sRegRewardData, Pack itemBag, int vipRatio, int regTimes) {
        if (sRegRewardData.getItemid() > 0 && sRegRewardData.getItemnum() > 0) {
            if (sRegRewardData.getItemnum() * vipRatio != itemBag.doAddItem(sRegRewardData.getItemid(), sRegRewardData.getItemnum() * vipRatio, 0, sRegRewardData.getIsbind(), "签到奖励", YYLoggerTuJingEnum.tujing_Value_jianglizhongxin, sRegRewardData.getItemid())) {
                MessageMgr.sendMsgNotify((long)this.roleId, (int)144965, null);
                return false;
            }
            MessageUtil.psendAddItemWhileCommit((long)this.roleId, (int)sRegRewardData.getItemid(), (int)sRegRewardData.getItemnum());
        }
        int mType = sRegRewardData.getMtype();
        switch (mType) {
            case 1: {
                if ((long)(sRegRewardData.getMoney() * vipRatio) != itemBag.addSysMoney((long)(sRegRewardData.getMoney() * vipRatio), "签到奖励", YYLoggerTuJingEnum.tujing_Value_jianglizhongxin, 0)) {
                    return false;
                }
                MessageUtil.pSendAddOrRemoveCurrency((long)this.roleId, (long)sRegRewardData.getMoney(), (int)1);
                break;
            }
            case 2: {
                if ((long)(sRegRewardData.getMoney() * vipRatio) != itemBag.addSysGold((long)(sRegRewardData.getMoney() * vipRatio), "签到奖励", YYLoggerTuJingEnum.tujing_Value_jianglizhongxin, 0)) {
                    return false;
                }
                MessageUtil.pSendAddOrRemoveCurrency((long)this.roleId, (long)sRegRewardData.getMoney(), (int)2);
                break;
            }
            case 3: {
                Procedure.pexecuteWhileCommit((Procedure)new PAddFuShi(userId, this.roleId, sRegRewardData.getMoney() * vipRatio, 1, YYLoggerTuJingEnum.tujing_Value_xitongzengsong));
                MessageUtil.pSendAddOrRemoveCurrency((long)this.roleId, (long)sRegRewardData.getMoney(), (int)3);
            }
        }
        ItemBaseBean itemBaseBeanData = new ItemBaseBean(sRegRewardData.getItemid(), sRegRewardData.getItemnum());
        ArrayList<ItemBaseBean> items = new ArrayList<ItemBaseBean>();
        items.add(itemBaseBeanData);
        RegBean regBeanData = new RegBean(9001, regTimes, items);
        YYLogger.signingLog((long)this.roleId, (RegBean)regBeanData);
        Procedure.pexecuteWhileCommit((Procedure)new PQueryRegRec(this.roleId));
        return true;
    }

    private int vipRatio(Sregreward sRegRewardData, int vipLv) {
        if (vipLv >= sRegRewardData.getRatio()) {
            return 2;
        }
        return 1;
    }
}

